Cyberduck Mountain Duck CLI

#7682 closed defect (fixed)

Orphaned file segments remain when a large object is overwritten

Reported by: joel-wright Owned by: dkocher
Priority: normal Milestone: 4.4.4
Component: openstack Version: 4.4.3
Severity: normal Keywords:
Cc: Architecture:
Platform:

Description

When a large object overwritten, either by another large object with a different size, or by a small object, the original segments that made up the file are left on the storage system in /.file-segments. This has the effect that every time a large object is overwritten the disk space used is not reclaimed. This can lead to a misunderstanding because the file-segments folder is hidden, and the user cannot see why their storage usage increases unless they show hidden files and have an understanding of swift large objects.

It would be nice if orphaned segments were cleaned up in a similar way to when a large object is deleted.

I have attached a simple patch against svn revision 14153 that implements the cleanup and can be disabled/enables using the Preferences object.

Attachments (1)

upload_cleanup.patch (4.7 KB) - added by joel-wright on Dec 15, 2013 at 11:55:31 PM.
Upload Cleanup Patch

Download all attachments as: .zip

Change History (8)

Changed on Dec 15, 2013 at 11:55:31 PM by joel-wright

Upload Cleanup Patch

comment:1 Changed on Dec 16, 2013 at 9:01:06 AM by joel-wright

  • Type changed from enhancement to defect

comment:2 Changed on Dec 17, 2013 at 11:25:56 AM by joel-wright

  • Summary changed from Orphaned file segments remain when a large object is overwritten to Openstack - Orphaned file segments remain when a large object is overwritten

comment:3 Changed on Dec 18, 2013 at 1:59:32 PM by dkocher

  • Milestone set to 4.5
  • Status changed from new to assigned

comment:4 Changed on Dec 28, 2013 at 9:47:36 PM by dkocher

  • Milestone changed from 4.5 to 4.4.4

comment:5 Changed on Dec 28, 2013 at 10:02:27 PM by dkocher

  • Summary changed from Openstack - Orphaned file segments remain when a large object is overwritten to Orphaned file segments remain when a large object is overwritten

comment:6 Changed on Dec 28, 2013 at 10:05:27 PM by dkocher

This patch will remove segments from the previous large object before the new upload is complete.

comment:7 Changed on Dec 28, 2013 at 10:11:52 PM by dkocher

  • Resolution set to fixed
  • Status changed from assigned to closed

In r14156. I have revised the patch to work both when overwriting with a segmented or single upload and no cleanup is made if appending to a previously interrupted large upload.

Note: See TracTickets for help on using tickets.
swiss made software